#!/usr/bin/perl -w
#
# ./bsqs.pl >52shuf.dat
# ./makeGraph.pl <52shuf.dat | gnuplot
# writes 52shuf.pdf

while (<>) {
    chomp;
    my @fields = split(/ +/);
    $recs{$fields[0]." ".$fields[1]." ".$fields[2]." ".$fields[3]} = \@fields;
}
print <<EOF;
set terminal pdf enhanced transparent font "Liberation Serif,7" size 2in,2.25in
set output "52shuf.pdf"
set boxwidth .8 relative
set border 0
set tics out
set xtics border nomirror
set ytics border nomirror
set ytics 0,100
set yrange [-5:*]
set style data histograms
set style fill solid 1.0 border -1
set datafile separator ","
unset xlabel
set ylabel "Total card position error (average)"
set xlabel "Sort algorithm"
set title "Errors sorting a deck of cards\\nwith 10% failed comparisons"
plot "-" using 2:xticlabels(1) with boxes notitle
EOF
print '"Quick",'.$recs{"1 1 10 0"}->[4]."\n";
print '"Merge",'.$recs{"1 1 10 0"}->[5]."\n";
print '"Bubble",'.$recs{"1 1 10 0"}->[6]."\n";
print "e\n";

print <<EOF;
set terminal pdf enhanced transparent font "Liberation Serif,7" size 2in,2.25in
set output "52shuf2.pdf"
set boxwidth .8 relative
set ytics 0,2
set yrange [-1:*]
set title "Errors sorting a deck of cards\\nwith 10% failed comparisons"
set xlabel "Sort algorithm"
plot "-" using 2:xticlabels(1) with boxes notitle
EOF
print '"Quick6",'.$recs{"1 6 10 0"}->[4]."\n";
print '"Merge6",'.$recs{"1 6 10 0"}->[5]."\n";
print '"Bubble",'.$recs{"1 1 10 0"}->[6]."\n";
print "e\n";

print <<EOF;
set terminal pdf enhanced transparent font "Liberation Serif,7" size 2in,2.25in
set output "52shuf3.pdf"
set boxwidth .8 relative
set ytics 0,100
set yrange [-1:*]
set title "Errors sorting a deck of cards\\nwith 10% failed comparisons\\nand 50% stuck outputs"
set xlabel "Sort algorithm"
plot "-" using 2:xticlabels(1) with boxes notitle
EOF
print '"Q",'.$recs{"1 1 10 50"}->[4]."\n";
print '"M",'.$recs{"1 1 10 50"}->[5]."\n";
print '"Q6",'.$recs{"1 6 10 50"}->[4]."\n";
print '"M6",'.$recs{"1 6 10 50"}->[5]."\n";
print '"B",'.$recs{"1 1 10 50"}->[6]."\n";
print "e\n";


print "quit\n";
